<template>
    <div class="grid__filters">
      <div
        class="grid__filter"
        v-for="(filter, index) in filters"
        :key="`filter-${index}`"
      >
        <FilterInput
          :filter="filter"
          @onChange="handleFilterChange"
        />
      </div>
    </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { Component, Inject } from 'vue-property-decorator';
import { Filter as FilterTypes } from '@/types';
import { namespace } from 'vuex-class';
import FilterInput from './filters/FilterInput.vue';

const grid = namespace('grid');

@Component({
  components: { FilterInput },
})
export default class GridFilters extends Vue {
  @Inject('gridFilters') private filtersConfig!: Array<FilterTypes>;

  public filters: Array<FilterTypes> = [...this.filtersConfig]

  @grid.Action
  public setGridFilters!: (filters: Array<FilterTypes>) => void;

  private handleFilterChange() {
    this.setGridFilters(this.filters);
  }
}
</script>
